//HavokCharacter.h
#ifndef	_HAVOKCHARACTER_H
#define _HAVOKCHARACTER_H


struct Vector2
{
    float x;
    float y;
};

struct D3DXVECTOR3;
struct D3DXVECTOR2;

class HavokCharacter
{
public:
	HavokCharacter();
	virtual ~HavokCharacter();

	void	Create( const hkVector4& position );
	void	Destroy();
	void	Update( const float fTimestep );
	void	LateUpdate();
	void	SetPosition( float x, float y, float z );
	void	SetVelocity( const D3DXVECTOR3* velocity );


    bool	IsActive() const 
	{ 
		return m_bActive; 
	}
    void	SetCameraControl( const bool bCameraControl ) 
	{ 
		m_bCameraControl = bCameraControl; 
	}

	hkTransform GetTransform();
    void		SetMovementDirection( const D3DXVECTOR2* xDirection ); 


protected:
	bool							m_bActive;
	bool							m_bCameraControl;
	bool							m_bOldJump;
    class	hkpCharacterRigidBody*	m_pHavokRigidBody;
    class	hkpCharacterContext*	m_characterContext;
	class	hkpConvexShape*			m_pStandShape;
    class	hkpCapsuleShape*		m_pCrouchShape;

			Vector2					m_xMovement;
			hkVector4				m_up;
			hkVector4				m_forward;

};

#endif