//HavokManager.h

#ifndef		_HAVOKMANAGER_H
#define		_HAVOKMANAGER_H

class	hkJobQueue;
class	hkJobThreadPool;
class	hkVisualDebugger;
class	hkpPhysicsContext;
class	hkStopwatch;

class HavokManager
{
public:
	enum 
	{
		LAYER_STATIC_BACKGROUND = 1,
		LAYER_ACTOR = 2,
	};

	static	bool	CreateInstance( bool bMultithread );
	static	void	ReleaseInstance();
	static	HavokManager*	Instance()
	{
		return m_pInstance;
	}
private:
	static HavokManager*	m_pInstance;
	HavokManager();

public:
	~HavokManager();

	void	ActiveVisualDebugger();
	void	Update();
	hkpWorld*	GetWorld()
	{
		return m_world;
	}


private:
	bool	Init( bool bMultithread );
	void	UnInit();
	void	StepSimulation( float dt );
	void	StepVisualDebugger( float dt );

private:
	bool				m_bActiveVisualDebugger;
	bool				m_bMultiThread;

	hkJobThreadPool*	m_threadPool;
	hkJobQueue*			m_jobQueue;
	hkpWorld*			m_world;

	hkVisualDebugger*	m_vdb;
	hkpPhysicsContext*	m_context;
	hkStopwatch*		m_stopWatch;
	hkReal				m_fLastTime;
	
};

#endif